//herosBow.cs
//herosBow and herosArrow weapon stuff

datablock AudioProfile(herosArrowHitSound)
{
   filename    = "Add-Ons/Weapon_Bow/ArrowHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(herosBowFireSound)
{
   filename    = "Add-Ons/Weapon_Bow/BowFire.wav";
   description = AudioClosest3d;
   preload = true;
};


//herosArrow trail
datablock ParticleData(herosArrowTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.7 0.7 1 0.2";
	colors[1]	= "0.7 0.7 1 0.0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(herosArrowTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = herosArrowTrailParticle;

   useEmitterColors = true;
   uiName = "Hero's Arrow Trail";
};

//effects
datablock ParticleData(herosArrowStickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.7 0.7 0.9 0.9";
	colors[1]     = "0.7 0.7 0.9 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(herosArrowStickExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "herosArrowStickExplosionParticle";

   useEmitterColors = true;
   uiName = "Hero's Arrow Stick";
};
datablock ExplosionData(herosArrowStickExplosion)
{
   //explosionShape = "";
	soundProfile = herosArrowHitSound;

   lifeTimeMS = 150;

   particleEmitter = herosArrowStickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};



datablock ParticleData(herosArrowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.5 0.5 0.7 0.9";
	colors[1]     = "0.5 0.5 0.7 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(herosArrowExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "herosArrowExplosionParticle";

   useEmitterColors = true;
};
datablock ExplosionData(herosArrowExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = herosArrowExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("herosArrowDirect",   '<bitmap:add-ons/Weapon_herosBow/CI_herosArrow> %1',    '%2 <bitmap:add-ons/Weapon_herosBow/CI_herosArrow> %1',0.5,1);

datablock ProjectileData(herosArrowProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Bow/Arrow.dts";

   directDamage        = 45;
   directDamageType    = $DamageType::herosArrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::herosArrowDirect;

   explosion             = herosArrowExplosion;
   stickExplosion        = herosArrowStickExplosion;
   bloodExplosion        = herosArrowStickExplosion;
   particleEmitter       = herosArrowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.25;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 65;
   velInheritFactor    = 1;

   uiName = "herosArrow";
};


//////////
// item //
//////////
datablock ItemData(herosBowItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Weapon_Bow/Bow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Hero's Bow";
	iconName = "Add-Ons/Weapon_Bow/icon_Bow";
	doColorShift = true;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = herosBowImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(herosBowImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Bow/Bow.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 10" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = herosBowItem;
   ammo = " ";
   projectile = herosArrowProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = herosBowItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

   stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "FireA";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "FireA";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.05;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFireA";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= HerosBowFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.5;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "FireA";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};

function herosBowImage::onFireA( %this, %obj, %slot )
{
	%bowFirer = %obj.client;
		if(%bowFirer.arrows >= 1)
		{		
			%oldarrows = %bowFirer.arrows;
			%bowFirer.arrows = (%oldarrows - 1);
			commandToClient(%bowFirer, 'bottomprint', "<color:FFFF00>Arrows:<color:FFFFFF>" SPC %bowFirer.arrows SPC "left in quiver", 3);
			%projectile = herosArrowProjectile;
			%shellcount = 1;

			for(%shell=0; %shell<%shellcount; %shell++)
			{
				%vector = %obj.getMuzzleVector(%slot);
				%objectVelocity = %obj.getVelocity();
				%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
				%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
				%velocity = VectorAdd(%vector1,%vector2);

				%p = new Projectile()
				{
					dataBlock = %projectile;
					initialVelocity = %velocity;
					initialPosition = %obj.getMuzzlePoint(%slot);
					sourceObject = %obj;
					sourceSlot = %slot;
					client = %obj.client;
				};
				MissionCleanup.add(%p);
			}
			return %p;
		}
		else
		{
			commandToClient(%bowFirer, 'bottomprint', "<color:FFFF00>You do not have any arrows left.", 3);
		}
}
